Update CMx Records

PUT /service/v2/cm/cmx

Available: Version 25.4 and later.

Purpose

Update records for Code and Record CMx.

Prerequisites

Ensure you have Update permission for Business Process Services.

Request Format

Send a request as a JSON map with the following structure:

{

"options":{

" cm_code": "<value>",

" class_name " : "<value>",

" project_number” : “<value>”

}

"data":[ {} ]

}

Request Parameters

Specify the following parameters in the Options JSON map:

Request Parameter Required? Data Type Description
cm_code Yes String A unique ID for the CM code. For example, “CM5”.
class_name Yes String The name of the CM class. For example, “Material Inventory Manager”.
project_number Yes String The name of the project. For example, "B-0001".

Response Format

A JSON object is returned in the following format:

{

"data": [],

"message": [<list of messages>],

"status": <REST status code value>,

"rest_audit_id": <id from the audit table>

}

A successful response displays a status code 200.

A failed response displays a message with a status code.

Sample Success Request

Send a request to retrieve a schedule of values (SOVs) in the following format:

{

"options": {

"cm_code": "CM5",

"class_name": "Material Inventory Manager",

"project_number": "B-0001"

},

"data": [

{

"ABDP01": null,

"ue_gen_UnitofMeasureSPD": "lump sum",

"upaItemUnitPrice": 0.0,

"upmManufacturerTXT120": "Oracle",

"umatReceivedQuantityDA": 0.0,

"uuu_cm5_name": "Ceilings_11001",

"CM_Barcode_C": null,

"umatCommittedSDA": 0.0,

"umatQtyOnHandSNL": 0.0,

"record_no": "uxmim-0001",

"umatRecItemUnitPriceSCA": 0.0,

"umatIniTotPriceCA": 0.0,

"uskuSkuAvgUnitPrice": 0.0,

"uskuQuantityInHandDA": 0.0,

"uuu_cm_navigation_code": "Ceilings-Oracle",

"umatSKUMtrDP": "Ceilings",

"uBuildingNumber": null,

"Short_Descrip_Default_Value": "Ceilings_11001",

"uuu_creation_date": "03-23-2025 13:42:31",

"uipInitialQtyDA": 0.0,

"uuu_cm5_status": "Active",

"umatAdjQtySNL": 110.0,

"umatSubTypePD": null,

"ujpAvUnitPricCA": 0.0,

"uuu_cm5_code": "Ceilings_Ceilings",

"ue_bld_PropertySubClassSPD": null,

"Material_Qnty": 0.0,

"umatSKUMasterNuberRN": "Ceilings",

"umatCategoryPD": "Ceilings",

"umatTotalPriceSNL": 30.0,

"uipQtyAdjDA": 120.0,

"uBuildingName": null,

"Material_Rcved": 120.0,

"ABLIDP01": null,

"creator_id": "Company Administrator",

"umatTotQtySNL": 0.0,

"ue_bld_PropertyClassSPD": null,

"umatSKUMtrDesc": null,

"AP_DA1": 0.0

}

]

}

Sample Success Response

A successful response with status code 200 displays in the following format:

{

"data": [

{

"ABDP01": null,

"ue_gen_UnitofMeasureSPD": "lump sum",

"upaItemUnitPrice": 0.0,

"upmManufacturerTXT120": "Oracle",

"umatReceivedQuantityDA": 0.0,

"uuu_cm5_name": "Ceilings_11001",

"CM_Barcode_C": null,

"umatCommittedSDA": 0.0,

"umatQtyOnHandSNL": 0.0,

"record_no": "uxmim-0001",

"umatRecItemUnitPriceSCA": 0.0,

"umatIniTotPriceCA": 0.0,

"uskuSkuAvgUnitPrice": 0.0,

"uskuQuantityInHandDA": 0.0,

"uuu_cm_navigation_code": "Ceilings-Oracle",

"umatSKUMtrDP": "Ceilings",

"uBuildingNumber": null,

"Short_Descrip_Default_Value": "Ceilings_11001",

"uuu_creation_date": "03-23-2025 13:42:31",

"uipInitialQtyDA": 0.0,

"uuu_cm5_status": "Active",

"umatAdjQtySNL": 110.0,

"umatSubTypePD": null,

"ujpAvUnitPricCA": 0.0,

"uuu_cm5_code": "Ceilings_Ceilings",

"ue_bld_PropertySubClassSPD": null,

"Material_Qnty": 0.0,

"umatSKUMasterNuberRN": "Ceilings",

"umatCategoryPD": "Ceilings",

"umatTotalPriceSNL": 30.0,

"uipQtyAdjDA": 120.0,

"uBuildingName": null,

"Material_Rcved": 120.0,

"ABLIDP01": null,

"creator_id": "Company Administrator",

"umatTotQtySNL": 0.0,

"ue_bld_PropertyClassSPD": null,

"umatSKUMtrDesc": null,

"AP_DA1": 0.0

}

],

"message": [],

"status": 200,

"rest_audit_id": 1463

}}

Supported Validation Messages and Status Codes

The following validation messages and status codes display in the response when incorrect values are provided in the request:

Field Name Use-case Scenario Status Code Error Message
cm_code Key is missing or an incorrect code. 778 CM code is not found.
cm_code Mandatory field is not included in the input data. 505 Create BP failed because Record <RECORD_ID> cannot be found.
class_name The key is missing or is an incorrect class. 779 Class Name is not found.
class_name Class is a company-type with a valid project number. 632 Class name is not at project level.
class_name Class is a project-type at the company-level. 632 Class name is not at company level.
class_name Sheet is not defined. 781 Sheet is not defined.
class_name A partial error. 3002 Invalid input.
project_number Key is missing or an incorrect value. 602 Project/Shell Number is not correct.
project_number Project is inactive or view-only, or on-hold. 1245 Create/Update/Delete cannot be performed when project/shell status is Inactive or View-Only or On-Hold.